#include <endian.h>
#include <byteswap.h>

/* maybe eventually remove anything we don't need (be macros) */

#if ( BYTE_ORDER == LITTLE_ENDIAN )
#define le16_to_cpu(x) (x)
#define le32_to_cpu(x) (x)
#define be16_to_cpu(x) bswap_16(x)
#define be32_to_cpu(x) bswap_32(x)
#elif ( BYTE_ORDER == BIG_ENDIAN )
#define le16_to_cpu(x) bswap_16(x)
#define le32_to_cpu(x) bswap_32(x)
#define be16_to_cpu(x) (x)
#define be32_to_cpu(x) (x)
#else
#error "cramfs only works on little-endian and big-endian systems"
#endif
