//
// de.gyronet.kangaroo.io.CombReflect.c
// kangaroo
//
// Created by Marc Kleine-Budde on 03.17.2003
// Copyright (c) 2003 GYRO net GmbH. All rights reserved.
//
// inspired by / copied from: java.io.FileInputStream.c
// from the Kaffe Project
//
// see original Copyright below... 

/*
 * java.lang.reflect.Method.c
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include "config-mem.h"
#include "../../../kaffe/kaffevm/gtypes.h"
#include "../../../kaffe/kaffevm/access.h"
#include "../../../kaffe/kaffevm/constants.h"
#include "../../../kaffe/kaffevm/object.h"
#include "../../../kaffe/kaffevm/classMethod.h"
#include "../../../kaffe/kaffevm/itypes.h"
#include "../../../kaffe/kaffevm/support.h"
#include "../../../kaffe/kaffevm/soft.h"
#include "../../../kaffe/kaffevm/exception.h"
#include "../../../kaffe/kaffevm/baseClasses.h"
#include "de_gyronet_kangaroo_lang_reflect_CombReflect.h"
#include <native.h>
#include "jni.h"
#include "defs.h"

JNIEXPORT jobject JNICALL
Java_de_gyronet_kangaroo_lang_reflect_CombReflect_newInstance(JNIEnv* env, jobject _this)
{
	Hjava_lang_Class* clazz;
	Method* meth;
	jint slot;
	jref ref;
	errorInfo info;

	/* Bit of a hack this */
	Hde_gyronet_kangaroo_lang_reflect_CombReflect* this = (Hde_gyronet_kangaroo_lang_reflect_CombReflect*)_this;
	jthrowable targetexc;

	clazz = unhand(this)->clazz;

	/* 
	 * A method invocation via reflection is a first active use, so
	 * initialize the class object.  (XXX: check whether that's true.)
	 */
	/* XXX use JNI here XXX */
	if (clazz->state < CSTATE_USABLE || (_this == NULL)) {
		if (processClass(clazz, CSTATE_COMPLETE, &info) == false) {
			throwError(&info);
		}
	}

	slot = unhand(this)->slot;
	assert(slot < clazz->nmethods);

	/* Note: we assume here that `meth' is identical to the jmethodID which
	 * would be returned by JNIEnv::GetMethodID for this method.
	 */
	meth = &CLASS_METHODS(clazz)[slot];
	ref = (*env)->NewObjectA(env, clazz, meth, NULL);

	targetexc = (*env)->ExceptionOccurred(env);
	if (targetexc != 0) {
		struct Hjava_lang_Throwable* e;

		(*env)->ExceptionClear(env);
		e = (struct Hjava_lang_Throwable *)execute_java_constructor(
			"java.lang.InstantiationException", 0, 0,
			"(Ljava/lang/Throwable;)V", targetexc);
		throwException(e);
		assert(!"Not here");
	}

	return ref;
}
