#include <sys/types.h>
#include "i802.h"

#include <dirent.h>
#include <jni.h>

/* close a directory handle which is provided as an integer */
JNIEXPORT 
void
Java_com_instant802_cldc_linuxfstools_DirectoryReader_rawCloseDirectory(JNIEnv *env, jobject ob, jint handle) {

	DIR *directoryHandle;

	/* get the directory handle from the first integer parameter */
	directoryHandle = (DIR *) handle;

	/* close the directory */
	if( directoryHandle ) {
		closedir( directoryHandle );
	}
}


/* given an integer representing the directory handle,
 * read a directory entry and return the filename as a string */
JNIEXPORT 
jstring
Java_com_instant802_cldc_linuxfstools_DirectoryReader_rawReadDirectory(JNIEnv *env, jobject ob, jint handle) {

	DIR *directoryHandle;
	struct dirent *directoryEntry;
	char *filename;
	jstring  jfilename = NULL;

	/* get the directory handle from the first integer parameter */
	directoryHandle = (DIR *)handle;

	/* read the next filename from the handle */
	directoryEntry = readdir( directoryHandle );

	if( directoryEntry ) {
		/* create a java string from the handle */
		filename = directoryEntry->d_name;
		jfilename =  (*env)->NewStringUTF(env,  filename);
	} else {
		/* if there's no filename, make sure that the handle is null */
		jfilename = NULL;
	}
	return jfilename;
}


/* open a directory and return the directory handle as an int */
JNIEXPORT 
jint
Java_com_instant802_cldc_linuxfstools_DirectoryReader_rawOpenDirectory(JNIEnv *env, jobject ob, jstring name) {

	jsize nameLength;
	jchar *jdirectoryName;
	char *directoryName;
	DIR *directoryHandle;

	directoryName = (*env)->GetStringUTFChars(env, name, NULL);

	/* open the directory */
	directoryHandle = opendir( directoryName );

	/* release the memory used for the name string */
	(*env)->ReleaseStringUTFChars(env, name, directoryName);

	/* return the directory handle as an integer */
	return ( (jint) directoryHandle );
}
