#include <jni.h>
#include "i802.h"

#include <stdio.h>
#include <openssl/ssl.h>
#include <openssl/tls1.h>
#include "com_i802_ssl_BIO.h"

extern void i802_ssl_init(void);


JNIEXPORT 
jint
	Java_com_instant802_cldc_ssl_BIO_nativeCreateBIOSMem(JNIEnv *env, jobject ob) {
	// (void)
		i802_ssl_init();		
		return (int)( BIO_new(BIO_s_mem()));
	}
	
JNIEXPORT 
jint
	Java_com_instant802_cldc_ssl_BIO_nativeCreateBIOFSSL(JNIEnv *env, jobject ob, 
			jint issl) {
	// (int pssl)
		BIO *pbio;
		SSL *pssl;
			
		i802_ssl_init();				
		pssl = (SSL *) issl;
		SSL_set_accept_state(pssl);  // Our filter objects are always a server
		pbio = BIO_new(BIO_f_ssl());
		BIO_set_ssl(pbio, pssl, BIO_NOCLOSE);
		return (int)(pbio);
	}	
	
JNIEXPORT
jint
	Java_com_instant802_cldc_ssl_BIO_nativeRead(JNIEnv *env, jobject ob, 
		 jint ibio, jbyteArray jbuf, jint size) {
	// (int ibio, byte[] buf, int size)
		int bytes;
		BIO *pbio;
		unsigned char *pbuff;

		i802_ssl_init();			
		pbuff = malloc(size);
		pbio = (BIO *) ibio; 		
		bytes = BIO_read(pbio, (void *)pbuff,  size);	
		if (bytes > 0) {
			(*env)->SetByteArrayRegion(env,  jbuf, 0, bytes, pbuff);
		}
		free(pbuff);
		return (jint)(bytes);
	}		

JNIEXPORT
void
	Java_com_instant802_cldc_ssl_BIO_nativeWrite(JNIEnv *env, jobject ob, 
		 jint ibio, jbyteArray jbuf, jint size) {
	// (int ibio, byte[] buf, int size)
		BIO *pbio;
		unsigned char *pbuff;
	
		i802_ssl_init();			
		pbuff = malloc(size);
		pbio = (BIO *) ibio; 		

	   (*env)->GetByteArrayRegion(env, jbuf, 0, size, pbuff);
		BIO_write(pbio, (void *)pbuff,  size);	
		free(pbuff);
	}		

JNIEXPORT 
jint
	Java_com_instant802_cldc_ssl_BIO_nativePending(JNIEnv *env, jobject ob,  jint ibio) {
	// (int ibio)
		BIO *pbio;

		i802_ssl_init();		
		pbio = (BIO *)ibio; 	
		return (jint)(BIO_ctrl_pending(pbio));
	}
	
JNIEXPORT 
void
	Java_com_instant802_cldc_ssl_BIO_nativeFree(JNIEnv *env, jobject ob,  jint ibio) {
	// (int ibio)
		BIO *pbio;

		i802_ssl_init();		
		pbio = (BIO *)ibio; 	
		BIO_free(pbio);
	}
	