#include <jni.h>
#include "i802.h"

#include <stdio.h>
#include <openssl/rc4.h>
#include <errno.h>

extern void i802_ssl_init(void);


JNIEXPORT 
jint
	Java_com_instant802_cldc_ssl_RC4_init(JNIEnv *env, jobject ob, jbyteArray jkey, jint keylen) {
		// (byte[] key, int keylen) - returns pointer to RC4_KEY 
		RC4_KEY *pkey;		
		char *pskey;
		
		i802_ssl_init();		
		pskey = (char *) malloc(keylen);
		pkey = (RC4_KEY *) malloc(sizeof(RC4_KEY));

		(*env)->GetByteArrayRegion(env, jkey, 0, keylen, pskey);		
		RC4_set_key(pkey, keylen,  pskey);
		free(pskey);
		return (jint) pkey;
	}

JNIEXPORT 
void
	Java_com_instant802_cldc_ssl_RC4_encrypt(JNIEnv *env, jobject ob,
	     jint ikey, jbyteArray jbin, jint len, jbyteArray jbout) {
	// (*pkeys, byte[] in, int inlen, byte[] out)
		char *bin, *bout;
		RC4_KEY *pkey;
		
		pkey  = (RC4_KEY *) ikey;
		
		bin = (char *) malloc(len);
		bout = (char *) malloc(len);
		(*env)->GetByteArrayRegion(env, jbin, 0, len, bin);		
		RC4(pkey,  len, bin,  bout);
		(*env)->SetByteArrayRegion(env, jbout, 0, len, bout);
		free(bin);
		free(bout);
	}
		
JNIEXPORT
void
	Java_com_instant802_cldc_ssl_RC4_free(JNIEnv *env, jobject ob, jint ikey) {
	// (*pkey)
		free((void *) ikey);
	}
