//
// de.gyronet.kangaroo.io.InetConnection.c
// kangaroo
//
// Created by Marc Kleine-Budde on 04.04.2003
// Copyright (c) 2003 GYRO net GmbH. All rights reserved.
//
// inspired by / copied from: java.net.InetAddressImpl.c
// from the Kaffe Project
//
// see original Copyright below... 

/*
 * java.net.InetAddress.c
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include "config-mem.h"
#include "config-net.h"
#include "config-io.h"
#include "../../../kaffe/kaffevm/gtypes.h"
#include "../../../kaffe/kaffevm/object.h"
#include <native.h>
#include "../../../kaffe/kaffevm/itypes.h"
#include "../../../kaffe/kaffevm/stringSupport.h"
#include "../../../kaffe/kaffevm/support.h"
#include "nets.h"
#include "jsyscall.h"
#include "../../../kaffe/kaffevm/debug.h"
#include "de_gyronet_kangaroo_io_URL.h"

/*
 * Convert a hostname to the primary host address.
 */
jint 
de_gyronet_kangaroo_io_URL_lookupHostAddr0
(struct Hjava_lang_String* str)
{
	char name[MAXHOSTNAME];
	struct hostent* ent;
	int rc;

	stringJava2CBuf(str, name, sizeof(name));

	rc = KGETHOSTBYNAME(name, &ent);
	if (rc) {
		if (ent == (void *)-1) {
			SignalError("java.io.IOException", SYS_ERROR(rc));
		} else {
			SignalErrorf("java.io.IOException", "%s: %s",
				     SYS_HERROR(rc), name);
		}
	}

	return ntohl(*(jint*)ent->h_addr_list[0]);
}
