/*
 * Created on Oct 28, 2003
 * 
 * To change the template for this generated file go to Window - Preferences -
 * Java - Code Generation - Code and Comments
 */
package de.gyronet.kangaroo.io;

import java.io.*;

import javax.microedition.io.DatagramConnection;
import javax.microedition.io.Datagram;

public class DatagramObject implements Datagram
{

	private static final int MAX_HOST_LENGTH = 256;

	DatagramConnection parent;
	byte[] buf;
	int off = 0;
	int len;

	int ipNumber;
	String host;
	int port;

	public DatagramObject(DatagramConnection parent, byte[] buf, int len)
	{
		this.parent = parent;
		setData(buf, 0, len);
	}

	public String getAddress()
	{
		if (host == null)
		{
			if (ipNumber == 0)
				return (null);
			//			try {
			//				byte[] tmp = new byte[MAX_HOST_LENGTH];
			/// parent.getHostByAddr(ipNumber, tmp);
			//				host = (new String(tmp)).trim();
			//			} catch (java.io.IOException ex) {}
			StringBuffer sb = new StringBuffer("");
			for (int i = 3; i >= 0; --i)
			{
				sb = sb.append(Integer.toString(0xff & (ipNumber >> (8 * i))));
				if (i > 0)
					sb.append(":");
			}
			host = sb.toString();
		}
		return ("datagram://" + host + ":" + port);
	}

	public byte[] getData()
	{
		return buf;
	}

	public int getOffset()
	{
		return off;
	}

	public int getLength()
	{
		return len;
	}

	public synchronized void setAddress(String addr) throws IOException
	{
		URL url;

		url = URL.parseURL(addr);
		host = url.host;
		port = url.port;
		ipNumber = url.addr;
	}

	public synchronized void setAddress(Datagram reference)
	{
		DatagramObject ref = (DatagramObject) reference;
		host = ref.host;
		port = ref.port;
		ipNumber = 0;
	}

	public synchronized void setData(byte[] buf, int offset, int length)
	{

		/* this will check to see if buf is null */
		if (length < 0 || offset < 0 || ((length + offset) > buf.length))
		{
			throw new IllegalArgumentException("Illegal length or offset");
		}
		this.buf = buf;
		this.off = offset;
		this.len = length;
	}

	public void setLength(int length)
	{
		setData(buf, off, length);
	}

	//
	// Read / write functions.
	//

	int pointer;

	public void reset()
	{
		setData(buf, 0, 0);
		pointer = 0;
	}

	public long skip(long n)
	{
		int min = Math.min((int) n, len - pointer);
		pointer += min;
		return (min);
	}

	public int read() throws IOException
	{
		if (pointer >= len)
		{
			return -1;
		}
		return buf[off + (pointer++)] & 0xFF;
	}

	public void write(int ch) throws IOException
	{
		if (pointer >= buf.length)
		{
			throw new IndexOutOfBoundsException();
		}
		buf[pointer++] = (byte) ch;
		off = 0;
		len = pointer;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataInput#readBoolean()
	 */
	public boolean readBoolean() throws IOException
	{
		// TODO Auto-generated method stub
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataInput#readByte()
	 */
	public byte readByte() throws IOException
	{
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataInput#readChar()
	 */
	public char readChar() throws IOException
	{
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataInput#readFully(byte[])
	 */
	public void readFully(byte[] b) throws IOException
	{
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataInput#readFully(byte[], int, int)
	 */
	public void readFully(byte[] b, int off, int len) throws IOException
	{
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataInput#readInt()
	 */
	public int readInt() throws IOException
	{
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataInput#readLong()
	 */
	public long readLong() throws IOException
	{
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataInput#readShort()
	 */
	public short readShort() throws IOException
	{
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataInput#readUnsignedByte()
	 */
	public int readUnsignedByte() throws IOException
	{
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataInput#readUnsignedShort()
	 */
	public int readUnsignedShort() throws IOException
	{
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataInput#skipBytes(int)
	 */
	public int skipBytes(int n) throws IOException
	{
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataOutput#write(byte[])
	 */
	public void write(byte[] b) throws IOException
	{
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataOutput#write(byte[], int, int)
	 */
	public void write(byte[] b, int off, int len) throws IOException
	{
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataOutput#writeBoolean(boolean)
	 */
	public void writeBoolean(boolean v) throws IOException
	{
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataOutput#writeByte(int)
	 */
	public void writeByte(int v) throws IOException
	{
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataOutput#writeChar(int)
	 */
	public void writeChar(int v) throws IOException
	{
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataOutput#writeChars(java.lang.String)
	 */
	public void writeChars(String s) throws IOException
	{
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataOutput#writeInt(int)
	 */
	public void writeInt(int v) throws IOException
	{
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataOutput#writeLong(long)
	 */
	public void writeLong(long v) throws IOException
	{
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataOutput#writeShort(int)
	 */
	public void writeShort(int v) throws IOException
	{
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.io.DataOutput#writeUTF(java.lang.String)
	 */
	public void writeUTF(String str) throws IOException
	{
		// TODO Auto-generated method stub

	}
}
