package java.io;

public class InputStreamReader extends Reader {
    private Reader in;



    public InputStreamReader(InputStream is) {
        in = new de.gyronet.kangaroo.io.ISO8859_1_Reader().open(is);
    }

    public InputStreamReader(InputStream is, String enc) throws UnsupportedEncodingException {
        if(!enc.equals("ISO8859_1")) throw new UnsupportedEncodingException();
        
        in = new de.gyronet.kangaroo.io.ISO8859_1_Reader().open(is);
    }



    public void close() throws IOException {
        if(in != null) {
            in.close();
            in = null;
        }
    }

    public void mark(int readAheadLimit) throws IOException {
        ensureOpen();
        if (in.markSupported()) {
            in.mark(readAheadLimit);
        } else {
            throw new IOException("mark() not supported");
        }
    }

    public boolean markSupported() {
        if(in == null) {
            return false;
        }
        return in.markSupported();
    }

    public int read() throws IOException {
        ensureOpen();
        return in.read();
    }

    public int read(char cbuf[], int off, int len) throws IOException {
        ensureOpen();
        if ((off < 0) || (off > cbuf.length) || (len < 0) ||
            ((off + len) > cbuf.length) || ((off + len) < 0)) {
            throw new IndexOutOfBoundsException();
        } else if (len == 0) {
            return 0;
        }
        return in.read(cbuf, off, len);
    }

    public boolean ready() throws IOException {
        ensureOpen();
        return in.ready();
    }

    public void reset() throws IOException {
        ensureOpen();
        in.reset();
    }

    public long skip(long n) throws IOException {
        ensureOpen();
        return in.skip(n);
    }



    private void ensureOpen() throws IOException {
        if (in == null) {
            throw new IOException("Stream closed");
        }
    }
}
