package javax.microedition.io;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import de.gyronet.kangaroo.io.ConnectionManager;

public class Connector {
    protected static ConnectionManager cm = getConnectionManager();

    public final static int READ = 0x01;
    public final static int WRITE = 0x02;
    public final static int READ_WRITE = READ | WRITE;	//= 0x03;
 
    private static ConnectionManager getConnectionManager() {
	try {
	    return (new de.gyronet.kangaroo.io.ConnectionManager());
	} catch(Exception e) {
	    throw new Error("could not initialize connector framework:" + e.getMessage());
	}
    }

    public static Connection open(String name) throws IOException {
	return(open(name, READ_WRITE, false));
    }

    public static Connection open(String name, int mode) throws IOException {
	return(open(name, mode, false));
    }

    public static Connection open(String name, int mode, boolean timeouts) throws IOException {
	return(cm.openConnection(name, mode, timeouts));
    }

    public static InputStream openInputStream(String name) throws IOException {
	InputConnection ic = (InputConnection)(open(name, READ));
	    return(ic.openInputStream());
    }

    public static DataInputStream openDataInputStream(String name) throws IOException {
	InputConnection ic = (InputConnection)(open(name, READ));
	    return(ic.openDataInputStream());
    }

    public static OutputStream openOutputStream(String name) throws IOException {
	OutputConnection oc = (OutputConnection)(open(name, WRITE));
	    return(oc.openOutputStream());
    }

    public static DataOutputStream openDataOutputStream(String name) throws IOException {
	OutputConnection oc = (OutputConnection)open(name, WRITE);
	    return(oc.openDataOutputStream());
    }
}
