#ifndef __LCL_AUTHALGORITHM_H___
#define __LCL_AUTHALGORITHM_H___

#include<stdarg.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include "xmlutils.h"
#include "auth_algorithm.h"

#define TRUE	1
#define FALSE	2

#define OPEN_SYSTEM_AUTH		1
#define SHARED_KEY_AUTH			2

/* columns present in station config tables */
#define AUTH_AUTHEN_ALGORITHM_OPEN_SYSTEM       "open-system-authentication"
#define AUTH_AUTHEN_ALGORITHM_SHARED_KEY        "shared-key-authentication"

struct auth_algo_data_info {
	char *auth_algo;
	int auth_algo_len;
	char *bss_value;
	int bss_value_len;
};

static int CheckAndRetrieveAuthAlgorithm(xmlDocPtr);
static int CheckAndRetrieveBssValueForAuthAlgo(xmlDocPtr);
static void lcl_auth_algorithm_xml(xmlDocPtr, xmlNodePtr);
static void lcl_bss_value_auth_xml(xmlDocPtr, xmlNodePtr);
static void GetAuthenticationAlgorithm(int , int );
static void GetAuthenticationAlgorithmEnable(int , int , int );
#endif  /* __LCL_AUTHALGORITHM_H__*/
