#ifndef __LCL_RESOURCE_INFO_H__
#define __LCL_RESOURCE_INFO_H__

#include<stdarg.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include "xmlutils.h"
#include "resource_info.h"

/* columns present in station config tables */
#define RES_INFO_MANUFACTURER_OUI               "manufacturer-oui"
#define RES_INFO_MANUFACTURER_NAME              "manufacturer-name"
#define RES_INFO_MANUFACTURER_PDT_NAME          "manufacturer-product-name"
#define RES_INFO_MANUFACTURER_PDT_VERSION       "manufacturer-product-version"

struct res_data_info {
	char *radio_value;
	int radio_value_len;
	char *bss_value;
	int bss_value_len;
	char *manufacturer_oui;
	int manufacturer_oui_len;
	char *manufacturer_name;
	int manufacturer_name_len;
	char *manufacturer_pdt_name;
	int manufacturer_pdt_name_len;
	char *manufacturer_pdt_version;
	int manufacturer_pdt_version_len;
};

static int CheckAndRetrieveManufacturerOUI(xmlDocPtr);
static int CheckAndRetrieveManufacturerName(xmlDocPtr);
static int CheckAndRetrieveManufacturerPDTName(xmlDocPtr);
static int CheckAndRetrieveManufacturerPDTVersion(xmlDocPtr);
static int CheckAndRetrieveBssValueForResInfo(xmlDocPtr );
static int CheckAndRetrieveRadioValueForResInfo(xmlDocPtr );

static void lcl_manufacturer_oui(xmlDocPtr, xmlNodePtr);
static void lcl_manufacturer_name(xmlDocPtr, xmlNodePtr);
static void lcl_manufacturer_pdt_name(xmlDocPtr, xmlNodePtr);
static void lcl_manufacturer_pdt_version(xmlDocPtr, xmlNodePtr);
static void lcl_bss_for_res_info_xml(xmlDocPtr , xmlNodePtr );
static void lcl_radio_for_res_info_xml(xmlDocPtr , xmlNodePtr );
static void GetManufacturerOUI(xmlDocPtr, int);
static void GetManufacturerName(xmlDocPtr, int);
static void GetManufacturerProductName(xmlDocPtr, int);
static void GetManufacturerProductVersion(xmlDocPtr, int);
#endif  /* __LCL_RESOURCE_INFO_H__*/
