#!/usr/bin/perl -w

=head1 NAME

print-schema

=head1 SYNOPSIS

Prints out the schema.pl file.

=head1 DESCRIPTION

This perl script prints out the schema.pl file.

It's main purpose is to be an example of how to use the schema.pl, and to
test that the schema.pl file has been generated correctly.

=head1 BUGS

The single warning:

C<Name "main::schema_list" used only once: possible typo at print-schema.pl line 22.>

is okay - perl thinks there's only one use of it, since the other use is in
schema.pl. Remove the -w from perl will get rid of this warning, but it may
also get rid of other useful warnings.

=cut

do 'schema.pl';

foreach $class (@schema_list) {
    if ($schema_info{$class}{'visible'} eq "yes") {
        print $schema_info{$class}{'name'} . ": " . 
            $schema_info{$class}{'summary'} . "\n";
    }
}
