/*
 * Created on Nov 13, 2003
 * author: Robin Barooah
 * (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.DataPath;

/**
 * @author robin
 * Implementing this interface indicates that the implementor
 * provides a method to append a representation of its data
 * as a well formed XML document.
 */
public interface AppendableAsXML {

	/**
	 * append a representation of the current object
	 * as a well formed object to the supplied stringbuffer
	 */
	void appendAsXML( StringBuffer buffer );

	/**
	 * the typename of this interface for use in Class.forName() statements.
	 */
	String TYPE = "com.instant802.cldc.DataPath.AppendableAsXML";
}
