/*
 * Created on Oct 5, 2003
 * written by robin
 * (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.LSQL;

import org.kxml2.kdom.Element;

import com.instant802.cldc.DataPath.XMLBase;
import com.instant802.cldc.DataPath.XMLRepresentationException;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 */
public class LSQLNotification extends XMLBase {

	public static String CONF_CHANGED = "conf_changed";
	public static String ORIGIN_ATTRIBUTE = "origin";
	
	private final Element root;

	public LSQLNotification(byte[] received) throws XMLRepresentationException {
		root = getRootElement( received );
	}

	public String typeName() {
		return root.getName();
	}

	public String origin() {
		String origin = root.getAttributeValue( "", ORIGIN_ATTRIBUTE );
		return origin == null ? "" : origin;
	}
	
	Element getRoot() {
		return root;
	}
	
	public void debug( String string ) {
		Log.debug("LSQLNotification", string );
	}
}
