/*
 * Created on Aug 13, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.channelplanner;

import java.util.Enumeration;
import java.util.Vector;

import com.instant802.cldc.Activation.ActivatorException;
import com.instant802.cldc.Activation.ServiceException;
import com.instant802.cldc.clustermembership.ClusterMember;
import com.instant802.cldc.clustermembership.ClusterMembership;
import com.instant802.cldc.orchestrator.OrchestratorNode;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class LocalWirelessNeighborhoodMonitorFactory {

	final OrchestratorNode node;
	/**
	 * @param membership
	 */
	public LocalWirelessNeighborhoodMonitorFactory( final OrchestratorNode node ) throws ActivatorException {
		this.node = node;
	}

	/**
	 * @return
	 */
	public Enumeration getMonitors() {
		Enumeration members = node.membershipAgent().getMembers();
		Vector monitors = new Vector();
		while( members.hasMoreElements() ) {
			LocalWirelessNeighborhoodMonitor monitor;
			ClusterMember member = (ClusterMember) members.nextElement();
			if (Log.DEBUG) debug("checking member for monitor " + member.ipAddress() );
			if( ! member.isNode( node ) ) {
				monitor = new LocalWirelessNeighborhoodMonitorProxy( member );
				monitors.addElement( monitor );
				if (Log.DEBUG) debug("added proxy");
			}
		}
		try {
			monitors.addElement( node.service( LocalWirelessNeighborhoodMonitor.TYPE ) );
		} catch (ServiceException e) {
			Log.warning("LocalWirelessNeighborhoodMonitorFactory", e );
		}
		return monitors.elements();
	}

	private void debug(String string) {
		Log.debug("LocalWirelessNeighborhoodMonitorFactory", string );
	}
}
