/*
 * Created on Jun 21, 2004
 * 
 * To change the template for this generated file go to Window - Preferences -
 * Java - Code Generation - Code and Comments
 */
package com.instant802.cldc.channelplanner;

import java.util.Enumeration;
import java.util.Hashtable;

import com.instant802.cldc.Activation.InvocationResult;
import com.instant802.cldc.DataPath.GenericRecord;
import com.instant802.cldc.clustermembership.ClusterMember;
import com.instant802.cldc.clustermembership.ManualClusterMember;
import com.instant802.cldc.hostapd.HostAPD;
import com.instant802.cldc.orchestrator.OrchestratorNode;
import com.instant802.cldc.util.Log;

/**
 * @author alan
 * 
 * To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
class Plan
{
	private String ip, mac, band;
	private String wlanname;
	private int oldchannel, newchannel;
	private long channelload;
	private long ts;
	private boolean locked;

	public Plan(
		String ip,
		String mac,
		String band,
		String wlanname,
		int oldchannel,
		int newchannel,
		long channelload,
		boolean locked)
	{
		this.ip = ip;
		this.mac = mac;
		this.band = band;
		this.wlanname = wlanname;
		this.oldchannel = oldchannel;
		this.newchannel = newchannel;
		this.channelload = channelload;
		this.ts = System.currentTimeMillis();
		this.locked = locked;
	}

	public long getChannelload()
	{
		return channelload;
	}

	public String getIp()
	{
		return ip;
	}

	public String getMac()
	{
		return mac;
	}
	
	public String getBand()
	{
		return band;
	}

	public int getNewchannel()
	{
		return newchannel;
	}

	public int getOldchannel()
	{
		return oldchannel;
	}

	public String getWlanName()
	{
		return wlanname;
	}

	public long getTS()
	{
		return ts;
	}

	public boolean isLocked()
	{
		return locked;
	}

	/**
	 * Event though activation is (now) re-enterant it still pays to split the local case off for efficiency's
	 * sake ..
	 */
	public int getCurChannel(OrchestratorNode node)
	{
		if (node.adminInterface().ipAddress().trim().equals(ip.trim()))
		{
			return Integer.parseInt(HostAPD.getHostAPD().getRadioChannel(wlanname));
		} else
		{
			ClusterMember host = new ManualClusterMember(ip);
			Hashtable args = new Hashtable();
			InvocationResult result;
			
			args.put(ChannelPlanExecutor.WLAN_NAME, wlanname);
			try
			{
				int channel = -1;
				result =
					host.InvokeMethod(
						LocalWirelessNeighborhoodMonitor.TYPE,
						"getWANChannel",
						args);
				Enumeration records = result.records().elements();
				GenericRecord record;
				while (records.hasMoreElements()) {
					record = (GenericRecord) records.nextElement();
					if (record.typeName().equals("ChannelRecord")) {
						channel = record.intField(ChannelPlanExecutor.CHANNEL_NUMBER);						
					}
				}
				return channel;
			} catch (Exception e)
			{
				if (Log.DEBUG)
					Log.debug("Plan: getCurChannel invocation failed: " + e.toString());
			}
			return -1;
		}
	}
}