/*
 * Created on Sep 26, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.clustermastering;

import com.instant802.cldc.DataPath.XMLRecord;
import com.instant802.cldc.DataPath.XMLRepresentationException;
import com.instant802.cldc.deviceconfiguration.ElementNotFoundException;
import com.instant802.cldc.messaging.Message;
import com.instant802.cldc.messaging.ReplyMechanism;
import com.instant802.cldc.net.SocketException;
import com.instant802.cldc.orchestrator.OrchestratorNode;
import com.instant802.cldc.util.DateUtil;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AnnounceMasterMessage extends Message {
	private static final String MEMBERS = "members";
	private static final String PRECEDENCE = "precedence";
	public static final String COORDINATOR = "coordinator";
	public static final String TYPE = "AnnounceMasterMessage";
	private final long timestamp;

	/**
	 * @param record
	 * @throws XMLRepresentationException
	 */
	public AnnounceMasterMessage(ReplyMechanism toReply, XMLRecord record)
		throws XMLRepresentationException {
		super(toReply, record);
		timestamp = DateUtil.now();
		if (Log.DEBUG) debug("timestamp is " + timestamp);
	}

	public AnnounceMasterMessage(final OrchestratorNode node)
		throws ElementNotFoundException {
		super(node);
		fromCoordinator(node.coordinationAgent().isServer());
		members(node.masterCriteria().members());
		precedence( node.masterCriteria().precedence());
		timestamp = DateUtil.now();		
	}

	private void members(int i) {
		intField(MEMBERS, i);
	}

	private void precedence( int i ) {
		intField(PRECEDENCE, i);
	}
	
	public int precedence() {
		return intField( PRECEDENCE );
	}
	
	public void onReceipt(OrchestratorNode node)
		throws ElementNotFoundException, SocketException {
			node.clusterMasterAgent().handleMasterAnnouncement(this);
	}

	public String typeName() {
		return TYPE;
	}

	public long getTimestamp() {
		return timestamp;
	}

	public boolean fromCoordinator() {
		return booleanField(COORDINATOR);
	}

	private void fromCoordinator(boolean value) {
		booleanField(COORDINATOR, value);
	}

	public int members() {
		return intField(MEMBERS);
	}
}
