/*
 * Created on Sep 26, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.clustermastering;

import java.io.IOException;

import com.instant802.cldc.messaging.Message;
import com.instant802.cldc.orchestrator.OrchestratorNode;
import com.instant802.cldc.util.DateUtil;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ClusterMaster {
	
	private final OrchestratorNode node;
	private final AnnounceMasterMessage message;
	private final long score;
	
	public ClusterMaster(OrchestratorNode node, AnnounceMasterMessage message ) {
		this.node = node;
		this.message = message;
		this.score = node.masterCriteria().messageScore( message );
	}

	public long age() {
		long age = DateUtil.now() - message.getTimestamp();
		return age;
	}

	public String getId() {
		return message.getSenderId();
	}

	/**
	 * @param string
	 */
	private void debug(String string) {
		Log.debug("ClusterMaster", string );
	}

	/**
	 * @return
	 */
	public boolean isLocal() {
		return getId().equals( node.getNodeId() );
	}

	/**
	 * @param message
	 */
	public void sendMessage( Message toSend) throws IOException {
		if (Log.DEBUG) debug("sending message");
		node.messageReceiver().sendMessage( toSend, this.message.getSenderIp() );
		if (Log.DEBUG) debug("message sent");
	}

	/**
	 * @return
	 */
	public String getAddress() {
		return message.getSenderIp();
	}

	public boolean sentMessage(AnnounceMasterMessage message) {
		return getId().equals( message.getSenderId() );
	}

	public long score() {
		return score;
	}
}
