/*
 * Created on Sep 29, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.deviceconfiguration;

import com.instant802.cldc.clustermastering.MasterCriteria;
import com.instant802.cldc.clustermembership.MembershipAgent;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class OrchestratorConfig extends ConfigObjectAdapter {

	public static final String TYPE = "cluster";
	private static final String FORMATION = "formation";
	private static final String IGNORE = "ignore";
	private static final String CLUSTERABLE = "clusterable";
	private static final String CLUSTER_ID = "cluster-id";
	private static final String  IS_COORDINATOR = "iscoordinator";
	private static final String COORDINATOR = "coordinatoraddress";
	public static final String LOCATION = "location";
	private static final String SETUPSHOWN = "setupshown";
	public static final String UNSET_LOCATION = "unset";
	public static final String RADIO_MAC = "wlan_mac";
	public static final String CONFIG_RESTORED = "config_restored";
	public static String[] PERSISTED_FIELDS = new String[] { CLUSTER_ID, IS_COORDINATOR, COORDINATOR, CLUSTERABLE };
	public static String[] SHARED_FIELDS = new String[] { SETUPSHOWN, FORMATION };
	public static final PKSingleton PK = new PKSingleton( TYPE );
	private final MasterCriteria criteria;

	/**
	 * @param element
	 */
	public OrchestratorConfig( MasterCriteria criteria, ConfigObject object ) {
		super( object );
		this.criteria = criteria;
	}

	/**
	 * @return
	 */
	public boolean hasCoordinator() {
		String coordinator = getCoordinatorAddress();
		return ( ( coordinator != null) && (coordinator.trim().length() > 0 ) );
	}
	
	public String getCoordinatorAddress() {
		String coordinator = field( COORDINATOR );
		return coordinator;
	}

	public boolean isCoordinator() {
		return booleanField( IS_COORDINATOR );
	}

	public boolean clusterable() {
		return booleanField( CLUSTERABLE );
	}

	public String location() {
		String location = field( LOCATION );
		return location.equals( UNDEFINED_FIELD ) ? UNSET_LOCATION : location;
	}

	public void setClusterable( boolean value ) {
		booleanField( CLUSTERABLE, value );
	}

	public boolean ignoreNewAPs() {
		return field( FORMATION ).equals( IGNORE );
	}

	/**
	 * @return
	 */
	public synchronized String getClusterId() {
		if (Log.DEBUG) debug("getting cluster id field");
		String id = field( CLUSTER_ID );
		if (Log.DEBUG) debug("field value is "+id);
		if( UNDEFINED_FIELD.equals(id)) {
			if (Log.DEBUG) debug("field is undefined, so returning "+MembershipAgent.NON_MEMBER);
			return MembershipAgent.NON_MEMBER;
		}
		if (Log.DEBUG) debug("returning "+id );
		return id;
	}

	private void debug(String string) {
		Log.debug("OrchestratorConfig", string );
	}

	/**
	 * @param string
	 */
	public synchronized void setClusterID(String string) {
		field( CLUSTER_ID, string );
//		criteria.setClusterId( getClusterId() );
		criteria.setClusterId( string );
	}
	
	public synchronized boolean configRestored() {
		return booleanField( CONFIG_RESTORED );
	}
}
