/*
 * Created on Oct 5, 2003 written by robin (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.deviceconfiguration;

/**
 * @author robin
 */
public class WirelessUser extends ConfigObjectAdapter
{

	public static final String TYPE = "radius-user";
	public static final PrimaryKey PK = Schema.PK_IS_NAME_ATTRIBUTE;

	private static String REALNAME = "realname";
	private static String DISABLED = "disabled";
	private static String USERNAME = "username";
	private static String PASSWORD = "password";
	private static String NTHASHEDPASSWORD = "nt_password_hash";

	public static final String[] SHARED_FIELDS =
		new String[] { REALNAME, USERNAME, NTHASHEDPASSWORD, DISABLED };
	private ConfigObject configobject;

	public WirelessUser(ConfigObject object)
	{
		super(object);
		configobject = object;
	}

	public String username()
	{
		return field(USERNAME);
	}

	public String realname()
	{
		return field(REALNAME);
	}

	public String plaintextPassword()
	{
		return field(PASSWORD);
	}

	public String hashedPassword()
	{
		return field(NTHASHEDPASSWORD);
	}

	public boolean disabled()
	{
		return field(DISABLED).trim().equals("1");
	}

	public String toXML()
	{
		StringBuffer sb = new StringBuffer();

		configobject.appendAsXML(sb);
		return sb.toString();
	}
	
	public ConfigObject getConfigObject() {
		return configobject;
	}
}
