/*
 * Created on Sep 5, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.discovery;

import com.instant802.cldc.DataPath.XMLRecord;
import com.instant802.cldc.DataPath.XMLRepresentationException;
import com.instant802.cldc.deviceconfiguration.ElementNotFoundException;
import com.instant802.cldc.messaging.Message;
import com.instant802.cldc.messaging.ReplyMechanism;
import com.instant802.cldc.net.SocketException;
import com.instant802.cldc.orchestrator.OrchestratorNode;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DiscoveryMessage extends Message {

	public static final String TYPE = "DiscoveryMessage";

	/**
	 * @param node
	 */
	public DiscoveryMessage(OrchestratorNode node) throws ElementNotFoundException {
		super( node );
	}

	public DiscoveryMessage( ReplyMechanism toReply, XMLRecord record ) throws XMLRepresentationException {
		super( toReply, record );
	}

	/* (non-Javadoc)
	 * @see com.instant802.cldc.DataPath.XMLRepresentation#typeName()
	 */
	public String typeName() {
		return TYPE;
	}

	/* 
	 * When a discovery message is received, the orchestrator node should 
	 * send back an announcement.
	 */
	public void onReceipt(OrchestratorNode node ) throws ElementNotFoundException, SocketException {
		if (Log.DEBUG) debug("sending announcement message");
		node.broadcastMessage(  new AnnouncementMessage( node ) );
		if (Log.DEBUG) debug("sent announcement message");
	}
	
	public void checkProtocolVersion() {
		if (Log.DEBUG) debug("discovery messages are accepted regardless of protocol version");
	}
}
	
