/*
 * Created on Sep 30, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.messaging;

import com.instant802.cldc.DataPath.XMLRecord;
import com.instant802.cldc.DataPath.XMLRepresentationException;
import com.instant802.cldc.clustermastering.AnnounceMasterMessage;
import com.instant802.cldc.clustermembership.MembershipAcceptedMessage;
import com.instant802.cldc.clustermembership.MembershipDeniedMessage;
import com.instant802.cldc.clustermembership.MembershipRequestMessage;
import com.instant802.cldc.coordination.ProbeRequestMessage;
import com.instant802.cldc.coordination.ProbeResponseMessage;
import com.instant802.cldc.discovery.AnnouncementMessage;
import com.instant802.cldc.discovery.DiscoveryMessage;
import com.instant802.cldc.synchronization.RequestSynchronizationMessage;
import com.instant802.cldc.synchronization.SynchronizationSetMessage;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MessageClassifier {

	public static Message classifyMessage( ReplyMechanism toReply, XMLRecord record )
		throws XMLRepresentationException, MessageNotUnderstoodException, BadMessageException  {
		Message message = getMessageClass( toReply, record );
		checkVersion( message );
		return message;
	}

	private static void checkVersion(Message message) throws BadMessageException {
		message.checkProtocolVersion();
	}

	private static Message getMessageClass( ReplyMechanism toReply, XMLRecord record )
		throws XMLRepresentationException, MessageNotUnderstoodException {
		String type = record.typeName();
		if( type.equals( DiscoveryMessage.TYPE )) {
			return new DiscoveryMessage( toReply, record );
		} else if ( type.equals( AnnouncementMessage.TYPE ) ) {
			return new AnnouncementMessage( toReply, record );
		} else if ( type.equals( AnnounceMasterMessage.TYPE ) ) {
			return new AnnounceMasterMessage( toReply, record );
		} else if ( type.equals( MembershipRequestMessage.TYPE ) ) {
			return new MembershipRequestMessage( toReply, record );
		} else if ( type.equals( MembershipAcceptedMessage.TYPE ) ) {
			return new MembershipAcceptedMessage( toReply, record );
		} else if ( type.equals( MembershipDeniedMessage.TYPE ) ) {
			return new MembershipDeniedMessage( toReply, record );
		} else if ( type.equals( RequestSynchronizationMessage.TYPE ) ) {
			return new RequestSynchronizationMessage( toReply, record ); 
		} else if ( type.equals( SynchronizationSetMessage.TYPE )) {
			return new SynchronizationSetMessage( toReply, record );
		} else if ( type.equals( ProbeRequestMessage.TYPE )) {
			return new ProbeRequestMessage( toReply, record );
		} else if ( type.equals( ProbeResponseMessage.TYPE )) {
			return new ProbeResponseMessage( toReply, record );
		}
		throw new MessageNotUnderstoodException( record );
	}
}
