/*
 * Created on Sep 16, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.net;

import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class HTTPResponse extends HTTPMessage {
	
	private final String response;
	private final int status_end;
	private final int status_code;

	public HTTPResponse(StringBuffer received) throws MalformedHTTPMessageException {
		this.response = new String( received );
		status_end = Parse( response );
		status_code = findStatusCode();
	}

	private int Parse( String response ) throws MalformedHTTPMessageException {
		int status_end = response.indexOf( CRLF );
		if( status_end < 0 )  throw new MalformedHTTPMessageException( "couldn't find end of status line" );
//		debug("status line is: " + response.substring(0, status_end ));
		return status_end;
	}

	/**
	 * @param string
	 */
	private void debug(String string) {
		Log.debug("HTTPResponse", string );
	}

	public int getStatusCode() {
		return status_code;
	}

	private int findStatusCode() throws MalformedHTTPMessageException {
		int code_start = response.indexOf( ' ' );
		int code_finish = response.indexOf( ' ', code_start + 1 );
		if( (code_start < 1) || (code_finish < 1) || (!(code_start < code_finish)) ) {
			throw new MalformedHTTPMessageException("couldn't find status code");
		}
		return Integer.parseInt( response.substring( code_start + 1, code_finish ) );
	}

	public byte[] getBody() throws MalformedHTTPMessageException {
		int start = status_end + CRLF.length();
		int headers_end = response.indexOf( CRLF + CRLF, start );
		if( headers_end >= 0 ) {
			headers_end += (CRLF.length() * 2);
		} else {
			headers_end = response.indexOf( LF + LF, start );
			if( headers_end >= 0 ) {
				headers_end += (LF.length() * 2 );
			} else {
				throw new MalformedHTTPMessageException("couldn't find end of headers " );
			}
		}
		return response.substring( headers_end ).getBytes();
	}

	/**
	 * @return
	 */
	public String getStatusLine() {
		return response.substring( 0, status_end );
	}
}
