/*
 * Created on Oct 29, 2003
 * author: Robin Barooah
 * (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.net;

/**
 * @author robin
 */
public class MacAddress {

	private final char SEPARATOR = ':';
	private final String address;
	private long numeric = 0;
	
	public MacAddress( String addressSpec ) {
		this.address = addressSpec;
	}

	public synchronized long asLong() {
		if( numeric == 0 ) {
			calculateNumeric();
		}
		return numeric;
	}

	private void calculateNumeric() {
		StringBuffer cleaned = new StringBuffer();
		for( int i = 0; i < address.length(); i++ ) {
			char found = address.charAt( i );
			if( found != SEPARATOR ) {
				cleaned.append( found );
			}
		}
		numeric = Long.parseLong( cleaned.toString(), 16 );
	}
}
