/*
 * Created on Aug 25, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.net;

import com.instant802.cldc.util.DateUtil;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Socket extends SocketBase {
	
	public Socket() throws SocketException {
		construct();
	}
	
	Socket( int sd ) {
		construct( sd );
	}
	
	public void connect( String host, int port ) throws SocketException {
		try{
			int err;
			
			/* try to connect, and timeout if necessary */ 
			checkOpen();
			
			// Returns EINTR in state when timeout occurs
			err = nativeConnect(sd, host, port, timeout);
			if (isEINTR(err)) {
				throw new SocketTimeoutException("timed out connecting");
			} else if (err < 0) {
				throw new SocketException( "connection failed" ); 
			}
		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
		}
	}
	
	public int read( byte[] buffer, int buffersize ) throws SocketException {
		try{
			int read;
			checkSizes(buffer, buffersize, "read" );		
			checkOpen();
			if (Log.DEBUG) Log.debug("nativeRead("+sd+", ..., " + timeout+")");
			read = nativeRead(sd, buffer, buffersize, timeout);
			
			// Handle EOF condition...
			if( isEPIPE( read ) ) {
				close();
				read = 0;
			}
			
			if (Log.DEBUG) Log.debug("nativeRead returned "+read);
			if (read <  0) {
				if (isEAGAIN(read) || isEINTR(read))
					throw new SocketTimeoutException("timed out during read");
				else
					throw new SocketException("error during read");
			}
			return read;
		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
			return 0;
		}
	}
	
	public int write( byte[] buffer, int buffersize ) throws SocketException {
		try{
		int written;
		checkSizes(buffer, buffersize, "write" );
		checkOpen();         
		written = nativeWrite(sd, buffer, buffersize );
		if( written <= 0) {
			throw new SocketException("error during write");
		}
		return written;
		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
			return 0;
		}
	}
	
	/**
	 * 
	 */
	public void setTimeout(int timeout ) {
		if (Log.DEBUG) debug("set timeout");
		this.timeout = timeout;
	}
	
	private void debug( String s ) {
		if (Log.DEBUG) Log.debug( "Socket", s);
	}
}
