/*
 * Created on Nov 14, 2003
 *
 * (c) 2003 Robin Barooah
 */
package com.instant802.cldc.nodestatus;

import com.instant802.cldc.DataPath.GenericRecord;
import com.instant802.cldc.util.Log;
import com.instant802.cldc.util.ThreadCounter;

/**
* (c) 2003 Instant802 Networks Inc
*/
public class NodeStatusRecord extends GenericRecord {

	private String THREADS_USED = "threads_used";
	private String SERVER = "server";
	private String CLIENT = "client";
	private String COORDINATION_MODE = "coordination_mode";
	private static final String MEMBER_COUNT = "member_count";
	private static String TYPE = "NodeStatusRecord";
	private static String CLUSTERING = "cluster_status";
	private static String THREAD_COUNT = "threads";
	private boolean clusterFailed = false;

	public String typeName() {
		return TYPE;
	}
	
	/**
	 * Update the record if the current cluster status has
	 * changed.
	 */
	public synchronized void setClusterStatus( String status ) {
		if( ! clusterFailed ) {
		if( ! status.equals( field( CLUSTERING )) ) {
			field( CLUSTERING, status );
			Log.notice( status );
		}
		}
	}
	
	public synchronized void setClusterFailureStatus( String status ) {
		if( ! clusterFailed ) {
			setClusterStatus( "CLUSTER FAILED: "+status );
			clusterFailed = true;
		}
	}

	public void setMemberCount(int i) {
		intField( MEMBER_COUNT, i );
	}

	public void setCoordinationMode(boolean b) {
		field( COORDINATION_MODE, b ? SERVER : CLIENT );
	}
	
	public void setThreadCount() {
		intField( THREAD_COUNT, Thread.activeCount() );
	}

	public void setThreadsUsed( int count ) {
		intField( THREADS_USED, count );
	}
}
