/*
 * Created on Jul 23, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package com.instant802.cldc.radius;

/**
 * @author alan
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class AVP
{
	private int off, length;

	private final byte[] data;

	public final static int AVP_TYPE_RESULT = 3;
	public final static byte AVP_RESULT_SUCCESS = 1, AVP_RESULT_FAILURE = 2;

	public AVP(byte[] data, int off, int length)
	{
		this.data = data;
		this.off = off;
		this.length = length;
	}

	public boolean isMandatory()
	{
		return 0 != (data[off + 0] & 0x80);
	}

	public int getType()
	{
		int type = data[off + 0];
		return 0x3FFF & ((type << 8) | data[off + 1]);
	}

	public boolean isResult()
	{
		return AVP_TYPE_RESULT == getType();
	}

	/**
	 * Assumes isResult() is true which must be verified externally.
	 * @return
	 */
	public boolean isSuccess()
	{
		return data[off + 5] == AVP_RESULT_SUCCESS;
	}

	public static AVP makeResult(boolean success)
	{
		byte[] data = new byte[6];
		data[0] = (byte) 0x80; // Mandatory
		data[1] = 0x03; // Result type
		data[2] = 0x00; // Hi order length of _Value_ field (!?!?!?)
		data[3] = 0x02; // Lo order length of                 etc
		data[4] = 0x00; // Hi order result field
		data[5] = success ? AVP_RESULT_SUCCESS : AVP_RESULT_FAILURE;
		return new AVP(data, 0, 6);
	}

	public byte[] getData()
	{
		if (0 == off && length == data.length)
			return this.data;
		else {
			byte[] buf = new byte[length];
			System.arraycopy(data, off, buf, 0, length);
			return buf;
		}
	}
}
