/*
 * Created on Jul 22, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package com.instant802.cldc.radius;

/**
 * @author alan
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class CHAPPacket
{
	/**
	 * @param b
	 * @param cs
	 * @param c
	 * @param ds
	 * @param i
	 */


	private byte[] data = null;

	static private byte idgen = 1;

	public static final  byte CHAP_UNDEFINED = 0,
		CHAP_CHALLENGE = 1,
		CHAP_RESPONSE = 2,
		CHAP_SUCCESS = 3,
		CHAP_FAILURE = 4;

	public CHAPPacket(
		byte code,
		byte id,
		byte[] value,
		byte valuesize,
		byte[] sysname,
		int sysnamelength)
	{
		int length, valueoff;
		if (CHAP_CHALLENGE == code || CHAP_RESPONSE == code)
		{
			valueoff = 5;
		}
		else
		{
			valueoff = 4;
		}
		data = new byte[valuesize + valueoff + sysnamelength];
		length = valuesize + valueoff;

		data[0] = code;
		data[1] = id;
		data[2] = (byte) (0xff & (length >> 8));
		data[3] = (byte) (0xff & length);
		if (5 == valueoff)
			data[4] = valuesize;
		System.arraycopy(value, 0, data, valueoff, valuesize);
		if (sysnamelength > 0 && null != sysname)
			System.arraycopy(sysname, 0, data, valueoff + valuesize, sysnamelength);
	}

	public CHAPPacket(byte code, byte[] value, byte valuesize)
	{
		this(code, CHAPPacket.getNextId(), value, valuesize, null, 0);
	}

	public CHAPPacket(byte code, byte[] value, byte valuesize, byte[] sysname, int sysnamesize)
	{
		this(code, CHAPPacket.getNextId(), value, valuesize, sysname, sysnamesize);
	}	
	
	public CHAPPacket(byte code, byte id, byte[] value, byte valuesize)
	{
		this(code, id, value, valuesize, null, 0);
	}	

	/**
	 * 255 >= ID > 0
	 * @return next id - wraps
	 */
	public static synchronized byte getNextId()
	{
		byte id = idgen;

		if (0 == (byte) ++idgen)
			++idgen;
		return idgen;
	}

	public byte getCode()
	{
		if (null != data)
			if (data.length > 0)
				return data[0];
		return CHAP_UNDEFINED;
	}

	public byte getId()
	{
		if (null != data)
			if (data.length > 1)
				return data[1];
		return 0;
	}

	public byte[] getData()
	{
		return data;
	}

	public void setId(byte id)
	{
		if (null != data)
			if (data.length > 1)
				data[1] = id;

	}
}
