/*
 * Created on Jun 24, 2003
 * 
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package com.instant802.cldc.radius;

import com.instant802.cldc.net.Datagram;
import com.instant802.cldc.util.Log;

/**
 * @author alan
 * 
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class Processor extends Thread
{

	private Proxy proxy;

	public Processor(Proxy p)
	{
		proxy = p;
	}

	public void run()
	{
		RadiusPacket rp;
		Datagram p;
		RadiusTransactionManager forwarder = proxy.getForwarder();

		while (Proxy.running && Proxy.receiveQueue.isOpen() )
		{
			try
			{
				p = (Datagram) Proxy.receiveQueue.dequeue();
				if (Log.DEBUG) debug("DQ'd packet");
				if (p.getLength() > 2)
				{
					rp = new RadiusPacket(p);
					if (forwarder.transactionStart(rp))
					{

						if (RadiusPacket.R_REQUEST == rp.getCode())
						{
							if (Log.DEBUG) debug(
								"------- PROCESSING REQUEST -----------");
							proxy.server.processRequest(rp);
							if (Log.DEBUG) debug("====== PROCESSED REQUEST=======");
						}
						else {
							if (Log.DEBUG) Log.info(
								"Radius: Got unknown packet type: "
									+ rp.getCode());
						}
					}
					else {
						if (Log.DEBUG) Log.info("Radius got duplicate request: dropping");
					}
				}
				else {
					if (Log.DEBUG) Log.info("Radius dropping malformed radius packet");
				}
			}
			catch (ClassCastException e)
			{
				if (Log.DEBUG) Log.info("Radius: Non-datagram on Q");
			}
			catch (Exception e)
			{
				if (Log.DEBUG) Log.info("Radius: task threw exception: " + e.toString());
			}
			try {Thread.sleep(10); } catch (Exception _) {}
		}
	}
	
	private void debug(String msg){
		if (Log.DEBUG) Log.debug("Radius: " +msg);
	}
}
