/*
 * Created on Jul 2, 2004
 * 
 * To change the template for this generated file go to Window - Preferences -
 * Java - Code Generation - Code and Comments
 */
package com.instant802.cldc.radius;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import com.instant802.cldc.Activation.Activator;
import com.instant802.cldc.Activation.InvocationMessage;
import com.instant802.cldc.Activation.InvocationResult;
import com.instant802.cldc.Activation.RecordCollection;
import com.instant802.cldc.Activation.Service;
import com.instant802.cldc.Activation.ServiceInstanceManager;
import com.instant802.cldc.DataPath.GenericRecord;
import com.instant802.cldc.DataPath.XMLRecord;
import com.instant802.cldc.LSQL.LSQLClient;
import com.instant802.cldc.LSQL.LSQLResultSet;
import com.instant802.cldc.deviceconfiguration.WirelessUser;
import com.instant802.cldc.orchestrator.OrchestratorNode;

/**
 * @author alan
 * 
 * To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public class WirelessUserManager extends Service
{
	private final OrchestratorNode node;
	private final static String TYPE = "WirelessUserManager";
	private final static String usersrecord = "usersrecord";

	public WirelessUserManager(OrchestratorNode node)
	{
		this.node = node;
	}

	protected boolean doMethod(
		String name,
		InvocationMessage message,
		InvocationResult result)
		throws Exception
	{
		if (name.equals("get_current_records"))
		{
			Hashtable wirelessusers = node.getRadiusServer().getWIrelessUsers();
			WirelessUser wu;
			Enumeration users = wirelessusers.keys();
			EmbeddedUserRecord xml;
			WirelessUserDatabase wud = new WirelessUserDatabase();
			while (users.hasMoreElements())
			{
				wu =
					(WirelessUser) wirelessusers.get(
						(String) users.nextElement());
				wud.add((GenericRecord) wu.getConfigObject());
			}
//			InvocationMessage im = new InvocationMessage("WirelessUserManager", "setCurrentRecords");
//			im.field(usersrecord, wud.asXMLDocument());
//			doMethod("setCurrentRecords", im, result);
			xml = new EmbeddedUserRecord();
			xml.field(usersrecord, wud.asXMLDocument());
			result.add(xml);
			return true;
		} else if (name.equals("set_current_records"))
		{;			
			String records = message.stringField(usersrecord);
			Vector users = (new WirelessUserDatabase(records.getBytes())).records();
			setUsers(users);
			return true;
		}
		return false;
	}

	private void setUsers(Vector users) throws Exception
	{
		LSQLClient lsql;
		LSQLResultSet lsqr;
		XMLRecord user;
		String username;
		String query, password, ntpassword;
		lsql = new LSQLClient(null);
		lsqr = lsql.query("<delete><radius-user/></delete>");
		for (int i = 0; i < users.size(); ++i) {
			user = (XMLRecord) users.elementAt(i);
			username = user.stringField("username");
			query = "<insert><radius-user name = \"" + username + "\">";
			query += setUserField(user, "username", null);
			query += setUserField(user, "realname", null);
			query += setUserField(user, "disabled", "0");
			// In case the file contains both nt_pass and pass do pass last to override nt_pass
			query += (ntpassword = setUserField(user, "nt_password_hash", null));
			query += (password = setUserField(user, "password", null));
			if (ntpassword.length() == 0 && password.length() == 0)
				throw new Exception("Bad password");
			lsqr = lsql.query(query + "</radius-user></insert>"); 
		}
		lsql.setRunningConfig();
	}

	private String setUserField(XMLRecord user, String name, String defaultval) {
		StringBuffer query = new StringBuffer();
		String value;
		if (null == (value = user.stringField(name)))
			value = defaultval;
		if (null == value)
			return "";
		query = query.append("<").append(name).append(">").append(value);
		query = query.append("</").append(name).append(">");
		return query.toString();
	}

	public static class InstanceManager extends ServiceInstanceManager
	{
		protected String typeName()
		{
			return WirelessUserManager.TYPE;
		}

		public Service getInstance(
			String name,
			OrchestratorNode node,
			Activator a)
			throws Exception
		{
			WirelessUserManager wum = new WirelessUserManager(node);
			a.addService(name, wum);
			return wum;
		}
	}
}

class EmbeddedUserRecord extends GenericRecord
{

	public String typeName()
	{
		return "EmbeddedUserRecord";
	}
}

class WirelessUserDatabase extends RecordCollection {
	private final String TYPE = "WirelessUserDatabase";

	public String typeName() {
		return TYPE;
	}

	public WirelessUserDatabase(byte[] bytes) throws Exception {
		super(bytes);
	} 

	public WirelessUserDatabase(){
		super();
	}
}
