/*
 * Created on Aug 15, 2003
 * 
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package com.instant802.cldc.radius.session;

import java.util.Hashtable;
import com.instant802.cldc.radius.Proxy;
import com.instant802.cldc.radius.EAPState;
import com.instant802.cldc.radius.RadiusPacket;
import com.instant802.cldc.util.Log;

/**
 * @author alan
 * 
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class AuthenticationHistoryImpl implements AuthenticationHistory
{
	private Hashtable sessions;

	public AuthenticationHistoryImpl()
	{
		this.sessions = new Hashtable();
	}

	/**
	 * Get AuthenticationRecord for a supplicant mac address
	 * 
	 * @param mac -
	 *                     mac address of session
	 * @return AuthenticationRecord or null if no session
	 */
	public AuthenticationRecord recordForMac(String mac)
	{
		mac = reformatMac( mac );
		AuthenticationRecord ar = new AuthenticationRecord();
		EventRecord er = (EventRecord) sessions.get(mac.trim());

		if (null == er)
			return null;

		ar.eventDetail =
			"" + er.detail + " - " + EAPState.getEventDetailString(er.detail);
		ar.authenticationEvent =
			(RadiusPacket.R_ACCEPT == er.event)
				? "Succesful authentication"
				: (RadiusPacket.R_REJECT == er.event)
				? "Failed authentication"
				: (RadiusPacket.R_CHALLENGE == er.event)
				? "Awaiting/processing authentication response"
				: "Unknown authentication state";
		ar.userName = er.user;
		ar.clientMac = er.mac;
		ar.eventTS = er.ts;
		ar.currentTS = System.currentTimeMillis();
		return ar;
	}

	private String reformatMac(String mac) {
		mac = mac.replace( ':', '-');
		mac = mac.toUpperCase();
		if (Log.DEBUG) debug("reformatted query mac to: " + mac );
		return mac;
	}


	private void debug(String string) {
		Log.debug("AuthenticationHistoryImpl", string );
	}

	public void createRecord(int event, EAPState eapstate) 
	{
		if (null != eapstate)
		{
			String user, mac;
			user = eapstate.getUsername();
			mac = eapstate.getUsermac();
			if (null == user)
				user = "unknown-user";
			if (null == mac)
				mac = "unknown-supplicant-mac";

			user = user.trim();
			mac = mac.trim();
			EventRecord er =
				new EventRecord(
					event,
					eapstate.getEventdetail(),
					System.currentTimeMillis(),
					user,
					mac);
			sessions.put(mac, er);
			if (Log.DEBUG) Log.debug(
				"AuthenticationSession user="
					+ user
					+ ", mac="
					+ mac
					+ ", event="
					+ event
					+ ", detail="
					+ eapstate.getEventdetail());
		}
	}

}

class EventRecord
{
	public int event;
	public int detail;
	public long ts;
	public String user;
	public String mac;
	/**
	 * @param event
	 * @param detail
	 * @param user
	 * @param mac
	 */
	public EventRecord(int event, int detail, long ts, String user, String mac)
	{
		this.event = event;
		this.detail = detail;
		this.ts = ts;
		this.user = user;
		this.mac = mac;
	}
}
