/*
 * Created on May 10, 2004
 * 
 * To change the template for this generated file go to Window - Preferences - Java -
 * Code Generation - Code and Comments
 */
package com.instant802.cldc.san;

/**
 * @author alan
 * 
 * To change the template for this generated type comment go to Window - Preferences -
 * Java - Code Generation - Code and Comments
 */

import java.util.Random;

import com.instant802.cldc.util.Log;

public class SAN
{

	float alpha, tempstart, tempend;
	int steps, metropolissteps;
	boolean debug = false;

	public SAN(float alpha, int steps, float tempstart, float tempend, int metropolissteps)
	{
		this.alpha = alpha;
		this.steps = steps;
		this.tempstart = tempstart;
		this.tempend = tempend;
		this.metropolissteps = metropolissteps;
	}

	public void run(SANGraph state) throws SanComputationException
	{
		float alpha = this.alpha;
		float tempend = this.tempend;
		int steps = this.steps;
		int metropolissteps = this.metropolissteps;
		int ii = 0;
		float temp = this.tempstart;
		float energy, lastenergy;
		Random random = new Random();

		try
		{
			lastenergy = energy = state.energy();
			while (ii < steps && temp > tempend && energy > 0.0f)
			{
				//System.out.println("Step = " + ii + " temp = " + temp + " energy = " +
				// energy);
				for (int m = 0; m < metropolissteps; ++m)
				{
					state.perturb();
					energy = state.energy();
					if (energy >= lastenergy)
					{
						if (random.nextFloat()
							>= (float) Math.exp((double) - (energy - lastenergy) / temp))
						{
							state.restoreState();
						}
						else
						{
							lastenergy = energy;
						}
					}
					else
						lastenergy = energy;
				}
				temp = alpha * temp;
				++ii;
			}
			if (Log.DEBUG)
				Log.debug("Number of SANsteps = " + ii);
		}
		catch (Exception e)
		{
			throw new SanComputationException(e.toString());
		}
	}

}
