/*
 * Created on Sep 4, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.util;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SyslogMessage {

	public static final int EMERGENCY = 0;
	public static final int ALERT = 1;
	public static final int CRITICAL = 2;
	public static final int ERROR = 3;
	public static final int WARNING = 4;
	public static final int NOTICE = 5;
	public static final int INFORMATIONAL = 6;
	public static final int DEBUG = 7;

	public static final String months[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

	private int severity = 7; // default is debug
	private int facility = 1; // default is user level
	private String message;
	private static String hostname = "unknown";
	private static String processname = "kaffe";
	private static long basetime = System.currentTimeMillis();
	
	public SyslogMessage( String message ) {
		this.message = message;
	}
	
	public static void setHostname( String name ) {
		hostname = name;
	}
	
	public static void setProcessname( String name ) {
		processname = name;
	}
	
	public void setPriority( int pri ) {
		this.severity = pri;
	}

	public void setFacility( int facility ) {
		this.facility = facility;
	}

	private int priority() {
		return severity + (facility * 8);
	}

	private String pri() {
		return "<" + priority() + ">";
	}

//	private static final String pad2( String padding, int value ) {
//		String result = ""+value;
//		result = (result.length() < 2) ? padding + result : result;
//		return result;
//	}

	private String hostname() {
		return hostname  +" ";
	}

	private String processname() {
		return processname + ": ";
	}

	private String msg() { 
		return processname() + message;
	}

	private String timestamp() {
		long time = System.currentTimeMillis() - basetime;
		return "[" + (time / 1000) + "." + (time % 1000) + "]";
	}

	public String toString() {
		return pri() + timestamp() + hostname() + msg();
	}
}
