There are two kinds of things we build.
1. Things that should use the host C compiler
2. Things that should use the target C compiler

There is some logic in make/vars.mk that sets some variables properly depending
on your target.  Specifically, if you target has the word 'tool' anywhere in it
then we will use the host tools, otherwise we use the cross-compiler.


---------------

The entire configuration system is base on the Linux kernel (v2.4) configurer.
A few changes have been made so we can integrate the entire system (rootfs and
kernel).

config/

This directory and its children is the heart of target system configurer.
Files in the top level are general in nature and do not depend on the target
system.  Subdirectories contain specific target configuration logic, scripts
and make rules.

cross-config.* : autoconf hints for particular targets.  These are taken
from/based on the dpkg-cross tools used by Debian.

config.in : system wide confiuration, independant of board, vendor or
    application.

<target>/config.in : Board/vendor specific configuration logic.  Some boards
require certain configuration options in order to function properly.

<target>/defconfig : Default top-level configuration for that board/vendor
(which applications to install on the root filesystem, how those applications
should be configured and the target kernel configuration.)

<target>/rules.mk : make rules specific to a particular target (or
flavor).


----------------

apps/

This directory contains external applications, tools, kernel modules or any
sort of code that is to be integrated into the oap build.  These directories
communicate with the rest of oap by the 'oap_build' script.  This script takes
1 argument:


 configure : prepare the source tree for building.  Some packages will not do
 anything here. Packages that use GNU autoconf will call the configure script
 and pass any ap-specific configure options.

 build : create object files 

 install : install files in target filesystem, or in the case of a host tool,
 install in the host tool directory.

 clean : remove objects


