all: image postbuild

postbuild:
	$(OAP_POSTBUILD_STEP)

# Convienience target, create a cross shell, tool will act as normal, but 
# you will be building for the target.
xshell:
	PS1='(XSHELL)\u@\h:\w\$$ ' \
	$(CONFIG_SHELL)

xshell-tools:
	PS1='(XSHELL-TOOLS)\u@\h:\w\$$ ' \
	$(CONFIG_SHELL)

clean_image:
	rm -rf $(DESTDIR)/*
	rm -rf Image_final/
	mkdir -p $(DESTDIR)

image: clean_image install $(IMAGE_TARGETS)

#####################################################################
# FIXME - 
#
# We need to order target libs (headers and libs need to be on build machine)
# with target binaries that need those libs to be installed on the build
# machine before the binaries can be built.
#

lib-subdir-y	 			=
lib-subdir-$(CONFIG_OAP_LIBPCAP)	+= apps/libpcap
lib-subdir-$(CONFIG_OAP_LIBXML)		+= apps/libxml2
lib-subdir-$(CONFIG_OAP_CLEARSILVER)	+= apps/clearsilver
lib-subdir-$(CONFIG_OAP_LIBIXML)	+= apps/libupnp/ixml
lib-subdir-$(CONFIG_OAP_BRIDGE_UTILS)	+= apps/bridge-utils/libbridge
lib-subdir-$(CONFIG_OAP_SNMP)		+= apps/liblsql
lib-subdir-y				+= instant802/libi802
lib-subdir-y				+= instant802/liblsqlquery


subdir-y	 			= instant802/rootskel
subdir-$(CONFIG_OAP_SNAPGEAR_LINUX)	+= apps/snapgear/linux-2.4.x
subdir-$(CONFIG_OAP_INTERSIL_LINUX)	+= apps/intersil/uClinux/kernel
subdir-$(CONFIG_OAP_LINUX)	 	+= apps/linux
subdir-$(CONFIG_OAP_MINI_HTTPD) 	+= apps/mini_httpd
subdir-$(CONFIG_OAP_UDHCP) 		+= apps/udhcp
subdir-$(CONFIG_OAP_WIRELESS_TOOLS) 	+= apps/wireless_tools
subdir-$(CONFIG_OAP_BRIDGE_UTILS)	+= apps/bridge-utils
subdir-$(CONFIG_OAP_PCMCIA_CS) 		+= apps/pcmcia-cs
subdir-$(CONFIG_OAP_BUSYBOX)		+= apps/busybox
subdir-$(CONFIG_OAP_IPTABLES)		+= apps/iptables
subdir-$(CONFIG_OAP_IPROUTE2)		+= apps/iproute2
subdir-$(CONFIG_OAP_IPERF)		+= apps/iperf
subdir-$(CONFIG_OAP_MTD)		+= apps/mtd
subdir-$(CONFIG_OAP_IEEE80211)		+= instant802/ieee80211
subdir-$(CONFIG_OAP_PPP)		+= apps/ppp
subdir-$(CONFIG_OAP_PPTP)		+= apps/pptp-linux
subdir-$(CONFIG_OAP_OPENSSL)		+= apps/open-ssl
subdir-$(CONFIG_OAP_APCONF)		+= instant802/apconf
subdir-$(CONFIG_OAP_DNSMASQ)		+= apps/dnsmasq
subdir-$(CONFIG_OAP_REDBOOT)		+= apps/ecos-build
subdir-$(CONFIG_OAP_TINYPROXY)		+= apps/tinyproxy
subdir-$(CONFIG_OAP_VALGRIND)		+= apps/valgrind
subdir-$(CONFIG_OAP_TCPDUMP)		+= apps/tcpdump
subdir-$(CONFIG_OAP_STRACE)		+= apps/strace
subdir-$(CONFIG_OAP_SYSSTAT)		+= apps/sysstat
subdir-$(CONFIG_OAP_NTPCLIENT)		+= apps/ntpclient
subdir-$(CONFIG_OAP_EBTABLES)		+= apps/ebtables
subdir-$(CONFIG_OAP_KAFFE)		+= apps/kaffe
subdir-$(CONFIG_OAP_J2ME)		+= instant802/j2me_cldc
subdir-$(CONFIG_OAP_LUA)		+= apps/lua
subdir-$(CONFIG_OAP_ORCHESTRATOR_CGI)	+= instant802/orchestrator-cgi
subdir-$(CONFIG_OAP_KICKSTARTD)		+= instant802/kickstartd
subdir-$(CONFIG_OAP_IXP425_ETH)		+= apps/ixp425/ixp425_eth
subdir-$(CONFIG_OAP_IXP425_ETH_1_2_2)	+= apps/ixp425/ixp425_eth_122
subdir-$(CONFIG_OAP_VCONFIG)		+= apps/vconfig
subdir-$(CONFIG_OAP_SNMP)		+= apps/net-snmp
subdir-$(CONFIG_OAP_PORTAL)		+= instant802/portal
subdir-$(CONFIG_OAP_KS8995M)		+= instant802/ks8995m
subdir-$(CONFIG_OAP_BUTTON)		+= instant802/button
subdir-$(CONFIG_OAP_LEDS)		+= instant802/leds
subdir-$(CONFIG_OAP_MFG_SCRIPTS)	+= instant802/mfg
subdir-$(CONFIG_OAP_DROPBEAR)		+= apps/dropbear
subdir-$(CONFIG_OAP_CLI)		+= instant802/clicmds
subdir-$(CONFIG_OAP_CONFIG_TOOLS)	+= instant802/config-tools
subdir-y				+= instant802/utils


ifdef CONFIG_OAP_RADIONET_LINUX
subdir-$(CONFIG_OAP_HW_WDOG)		+= apps/radionet/watchdogd
endif

# Extra directories to clean that are not built using the generic
# mechanism above

cleandir-$(CONFIG_OAP_ATHEROS_LINUX)	+= apps/atheros/linux


# These are target libraries.  They are installed on the build machine
# so the headers and libs are available when we want to build target 
# executables.
lib-subdirs:
	set -e; \
	for dir in $(lib-subdir-y) ; do \
	  echo "**** Build Library $$dir"; \
          if [ -f $$dir/oap_build ] ; then \
	    (cd $$dir && ./oap_build build) || exit 1; \
	  else \
	    $(MAKE) -C $$dir || exit 1; \
	  fi; \
	done

# build files for target
subdirs: lib-subdirs
	set -e; \
	for dir in $(subdir-y) ; do \
	  echo "**** Building $$dir"; \
          if [ -f $$dir/oap_build ] ; then \
	    (cd $$dir && ./oap_build build) || exit 1; \
	  else \
	    $(MAKE) -C $$dir || exit 1; \
	  fi; \
	done

ifeq ($(CONFIG_OAP_STATISTICS),y)
DO_STATS= \
	  RAW=`du -bs $(DESTDIR) | cut -f 1`; \
	  COMPRESSED=`tar -czO $(DESTDIR) | wc -c`; \
	  (printf "%d\t%d\t%s\n" \
	  	$$RAW $$COMPRESSED \
		`echo $$dir | sed -e 's|^apps/||'` >> flash-usage.txt );
else
DO_STATS= 
endif

# install files into target directory
install: subdirs
	-rm flash-usage.txt
	set -e; \
	for dir in $(subdir-y) ; do \
	  echo "**** Installing $$dir"; \
	  if [ -f $$dir/oap_build ] ; then \
	    (cd $$dir && ./oap_build install) || exit 1; \
	  else \
	    $(MAKE) -C $$dir install  || exit 1; \
	  fi; \
	$(DO_STATS) \
	done

clean:
	rm -rf $(DESTDIR) 
	set -e; \
	for dir in $(lib-subdir-y) $(subdir-y) $(cleandir-y) ; do \
	  echo "**** Cleaning $$dir"; \
	  if [ -f $$dir/oap_build ] ; then \
	    (cd $$dir && ./oap_build clean ); \
	  else \
	    $(MAKE) -C $$dir clean ; \
	  fi; \
	done

tools: common_tools $(TARGET_TOOLS)
	$(MAKE) oldconfig

clean_tools: clean_common_tools

common_tools: $(FIRST_TARGET_TOOLS)
	(cd apps/clearsilver-ct && \
	    ./oap_build configure && \
	    ./oap_build build && \
	    ./oap_build install) 	|| exit 1;
	(cd apps/tidy && \
	    ./oap_build configure && \
	    ./oap_build build && \
	    ./oap_build install)	|| exit 1;
	(cd apps/filepp && \
	    ./oap_build configure && \
	    ./oap_build build && \
	    ./oap_build install)	|| exit 1;
	(cd apps/genext2fs && \
	    ./oap_build $(OAP_TOPDIR)/.config build)	|| exit 1;
	(cd apps/cramfs && \
	    make)			|| exit 1;
	(cd apps/squashfs-tools && \
	    make)			|| exit 1;
ifdef CONFIG_OAP_RADIONET_LINUX
	(cd apps/radionet/mkimage && \
	    make)			|| exit 1;
endif


clean_common_tools: $(CLEAN_TARGET_TOOLS)
	cd apps/clearsilver-ct && ./oap_build clean
	cd apps/tidy && ./oap_build clean
	cd apps/filepp && ./oap_build clean
	cd apps/genext2fs && make clean
	cd apps/cramfs && make clean
	cd apps/squashfs-tools && make clean

apps_config:
	@if [ -f $(CONFIG_OAP_CROSS_COMPILE)gcc ] ; then \
	  set -e; \
	  for dir in $(lib-subdir-y) $(subdir-y) ; do \
	    if [ -f $$dir/oap_build ] ; then \
	      echo "**** Configuring $$dir"; \
	      (cd $$dir && ./oap_build configure) || exit 1; \
	    fi; \
	  done; \
	else \
	  echo "*** Cross-compiler not available, configuration incomplete";\
	fi

$(BUILDTIME_FILE):
	mkdir -p $(@D)
	date > $@
	sync

buildtime_file: $(BUILDTIME_FILE)
