// poll.js - allow client to poll configuration objects while avoiding page refresh.
/* Copyright 2004 Instant802 Networks, Inc. All Rights Reserved. */
// The default config object is cluster
// tbd: handle multiple requerst/timers.
// tbd: change to combination of object e.g. "cluster" and properties e.g. "locally_modified"
var _script = "orchestrator.cgi?poll=locally_modified";
var _timer;
var _interval;
function firstReload() {
reloadScript();
_timer=setInterval('reloadScript()', _interval); // subsequent polls at intervals of _interval milliseconds.
}
function reloadScript() {
var head = document.getElementsByTagName('head').item(0);
var old  = document.getElementById('scriptId');
if (old) head.removeChild(old);
script = document.createElement('script');
var now= new Date();
script.src = _script + "@" + now.valueOf();
script.type = 'text/javascript';
script.defer = true;
script.id = 'scriptId';
void(head.appendChild(script));
}
// every t milliseconds poll the specified server script for the for the given object property, after waiting an initial delay milliseconds.
function startPollingObject( t, serverAction, object, property, delay ) {
var pollRequest;
if(object) {
pollRequest = '?poll=' + object.toString() + '.' + property.toString();
}
else {
pollRequest = '?poll=' + property.toString();
}
if(serverAction) {
_script = serverAction.toString() + pollRequest;
}
else {
_script = 'orchestrator.cgi' + pollRequest;
}
_interval=t;
_timer=setTimeout('firstReload()', delay); // first poll at delay
}
// poll the cluster object once for the indicated property.
function poll( prop ) {
_script = 'orchestrator.cgi?poll=cluster.' + prop.toString();
reloadScript();
}
// t: polling time in milliseconds
// prop: cluster property to be queried.
function startPolling(t, prop){
startPollingObject( t, null, 'cluster', prop, 0 );
}
function stopPolling() {
void(clearInterval(_timer));
}
/* Example of use:
In your html you have something like the following:
<p>The server, via the poll handler, tells me: <span id="pollResponse"></span></p>
<a href="javascript:void(startPolling(2000))">Start Polling!</a>;
<a href="javascript:void(stopPolling());">Stop polling</a>
In the server-side handler you should return "document.getElementById('pollResponse').innerHTML='dyanamic response text'";
This will cause the writing of "dyanamic response text" within the span tag above.
*/
